/// <reference types="google.maps" />

import * as react from 'react';
import { ComponentProps } from 'react';
import { C as CommonProps } from '../types-6fqaupRi.js';

type CircleProps = ComponentProps<typeof Circle>;
declare const Circle: react.ForwardRefExoticComponent<Partial<{
    onCenterChanged: (this: google.maps.Circle, center: google.maps.LatLng) => void;
    onRadiusChanged: (this: google.maps.Circle, radius: number) => void;
    onClick: (this: google.maps.Circle, e: google.maps.MapMouseEvent) => void;
    onContextMenu: (this: google.maps.Circle, e: google.maps.MapMouseEvent) => void;
    onDblClick: (this: google.maps.Circle, e: google.maps.MapMouseEvent) => void;
    onDrag: (this: google.maps.Circle, e: google.maps.MapMouseEvent) => void;
    onDragEnd: (this: google.maps.Circle, e: google.maps.MapMouseEvent) => void;
    onDragStart: (this: google.maps.Circle, e: google.maps.MapMouseEvent) => void;
    onMouseDown: (this: google.maps.Circle, e: google.maps.MapMouseEvent) => void;
    onMouseMove: (this: google.maps.Circle, e: google.maps.MapMouseEvent) => void;
    onMouseOut: (this: google.maps.Circle, e: google.maps.MapMouseEvent) => void;
    onMouseOver: (this: google.maps.Circle, e: google.maps.MapMouseEvent) => void;
    onMouseUp: (this: google.maps.Circle, e: google.maps.MapMouseEvent) => void;
    onRightClick: (this: google.maps.Circle, e: google.maps.MapMouseEvent) => void;
} & {
    center: NonNullable<google.maps.LatLng | google.maps.LatLngLiteral | null>;
    draggable: boolean;
    editable: boolean;
    radius: number;
    visible: boolean;
} & CommonProps<google.maps.Circle>> & react.RefAttributes<google.maps.Circle>>;

export { type CircleProps, Circle as default };
