/// <reference types="google.maps" />

import * as react from 'react';
import { ComponentProps } from 'react';
import { C as CommonProps, P as PreventLoadProps } from '../types-6fqaupRi.js';

type DrawingManagerProps = ComponentProps<typeof DrawingManager>;
declare const DrawingManager: react.ForwardRefExoticComponent<Partial<{
    onCircleComplete: (this: google.maps.drawing.DrawingManager, circle: google.maps.Circle) => void;
    onMarkerComplete: (this: google.maps.drawing.DrawingManager, marker: google.maps.Marker) => void;
    onOverlayComplete: (this: google.maps.drawing.DrawingManager, event: google.maps.drawing.OverlayCompleteEvent) => void;
    onPolygonComplete: (this: google.maps.drawing.DrawingManager, polygon: google.maps.Polygon) => void;
    onPolylineComplete: (this: google.maps.drawing.DrawingManager, polyline: google.maps.Polyline) => void;
    onRectangleComplete: (this: google.maps.drawing.DrawingManager, rectangle: google.maps.Rectangle) => void;
} & {
    drawingMode: NonNullable<google.maps.drawing.OverlayType | null>;
} & CommonProps<google.maps.drawing.DrawingManager>> & PreventLoadProps & react.RefAttributes<google.maps.drawing.DrawingManager>>;

export { type DrawingManagerProps, DrawingManager as default };
