/// <reference types="google.maps" />

import * as react from 'react';
import { SuspenseProps, ComponentProps } from 'react';
import { C as CommonProps } from '../types-6fqaupRi.cjs';

type GoogleMapProps = ComponentProps<typeof GoogleMap>;
declare const GoogleMap: react.ForwardRefExoticComponent<Partial<{
    onBoundsChanged: (this: google.maps.Map, bounds: google.maps.LatLngBounds) => void;
    onCenterChanged: (this: google.maps.Map, center: google.maps.LatLng) => void;
    onDrag: (this: google.maps.Map) => void;
    onDragEnd: (this: google.maps.Map) => void;
    onDragStart: (this: google.maps.Map) => void;
    onHeadingChanged: (this: google.maps.Map, heading: number) => void;
    onIdle: (this: google.maps.Map) => void;
    onMapTypeIdChanged: (this: google.maps.Map, mapTypeId: string) => void;
    onProjectionChanged: (this: google.maps.Map, projection: google.maps.Projection) => void;
    onResize: (this: google.maps.Map) => void;
    onTilesLoaded: (this: google.maps.Map) => void;
    onTiltChanged: (this: google.maps.Map, tilt: number) => void;
    onZoomChanged: (this: google.maps.Map, zoom: number) => void;
    onClick: (this: google.maps.Map, e: google.maps.MapMouseEvent) => void;
    onContextMenu: (this: google.maps.Map, e: google.maps.MapMouseEvent) => void;
    onDblClick: (this: google.maps.Map, e: google.maps.MapMouseEvent) => void;
    onMouseDown: (this: google.maps.Map, e: google.maps.MapMouseEvent) => void;
    onMouseUp: (this: google.maps.Map, e: google.maps.MapMouseEvent) => void;
    onMouseMove: (this: google.maps.Map, e: google.maps.MapMouseEvent) => void;
    onMouseOut: (this: google.maps.Map, e: google.maps.MapMouseEvent) => void;
    onMouseOver: (this: google.maps.Map, e: google.maps.MapMouseEvent) => void;
    onRightClick: (this: google.maps.Map, e: google.maps.MapMouseEvent) => void;
} & {
    center: NonNullable<google.maps.LatLng | google.maps.LatLngLiteral>;
    clickableIcons: boolean;
    heading: number;
    mapTypeId: string;
    streetView: google.maps.StreetViewPanorama;
    zoom: number;
} & CommonProps<google.maps.Map>> & Pick<react.DetailedHTMLProps<react.HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "style" | "className" | "id"> & Pick<SuspenseProps, "fallback"> & {
    children?: react.ReactNode | undefined;
} & react.RefAttributes<google.maps.Map>>;

export { type GoogleMapProps, GoogleMap as default };
