import { handleHas_default, getConnectedEventsAndProps_default, useHandlersAndProps_default } from './chunk-HVIYR2JS.js';
import { MAPS } from './chunk-IGDL35GK.js';
import { MapContext_default } from './chunk-ENX7YFEM.js';
import { forwardRef, useContext, useLayoutEffect } from 'react';
import setRef from 'react-helpful-utils/setRef';
import { GoogleMapsLoader } from 'google-maps-js-api-loader';

var isKeyOmitted = handleHas_default([
  "defaultOptions",
  "preventLoad"
]);
var handleComponent = (instancePath, connectedProps) => {
  const connectedEventsAndProps = getConnectedEventsAndProps_default(connectedProps);
  const [library, className] = instancePath;
  let isUnsafe = library != MAPS;
  let InstanceClass;
  return forwardRef((props, ref) => {
    if (isUnsafe) {
      const status = GoogleMapsLoader.getStatus(library);
      if (status != "loaded") {
        throw (status != "error" ? props.preventLoad ? GoogleMapsLoader.getCompletion : GoogleMapsLoader.load : GoogleMapsLoader.getError)(library);
      } else {
        isUnsafe = false;
      }
    }
    const map = useContext(MapContext_default);
    useLayoutEffect(() => {
      if (!InstanceClass) {
        InstanceClass = GoogleMapsLoader.get(library)[className];
      }
      const instance = new InstanceClass({
        map,
        ...props.defaultOptions,
        ...props
      });
      setInstance(instance);
      setRef(ref, instance);
      return () => {
        instance.setMap(null);
        setRef(ref, null);
      };
    }, []);
    const setInstance = useHandlersAndProps_default(
      props,
      connectedEventsAndProps,
      isKeyOmitted
    );
    return null;
  });
};
var handleComponent_default = handleComponent;

export { handleComponent_default };
//# sourceMappingURL=chunk-A4FNBC32.js.map
//# sourceMappingURL=chunk-A4FNBC32.js.map