'use strict';

var googleMapsJsApiLoader = require('google-maps-js-api-loader');

// src/utils/createUseLibrary.ts
var createUseLibrary = (getCompletion) => (...libraries) => {
  const l = libraries.length;
  if (l < 2) {
    const status = googleMapsJsApiLoader.GoogleMapsLoader.getStatus(...libraries);
    if (status == "loaded") {
      return l ? googleMapsJsApiLoader.GoogleMapsLoader.get(libraries[0]) : void 0;
    }
    throw status != "error" ? getCompletion(...libraries) : googleMapsJsApiLoader.GoogleMapsLoader.getError(libraries[0]);
  }
  const libs = [];
  for (let i = 0; i < l; i++) {
    const library = libraries[i];
    const lib = googleMapsJsApiLoader.GoogleMapsLoader.get(library);
    if (!lib) {
      throw googleMapsJsApiLoader.GoogleMapsLoader.getStatus(library) != "error" ? getCompletion(...libraries) : googleMapsJsApiLoader.GoogleMapsLoader.getError(library);
    }
    libs.push(lib);
  }
  return libs;
};
var createUseLibrary_default = createUseLibrary;

exports.createUseLibrary_default = createUseLibrary_default;
//# sourceMappingURL=chunk-CQLHWBAX.cjs.map
//# sourceMappingURL=chunk-CQLHWBAX.cjs.map