import { GoogleMapsLoader } from 'google-maps-js-api-loader';

// src/utils/createUseLibrary.ts
var createUseLibrary = (getCompletion) => (...libraries) => {
  const l = libraries.length;
  if (l < 2) {
    const status = GoogleMapsLoader.getStatus(...libraries);
    if (status == "loaded") {
      return l ? GoogleMapsLoader.get(libraries[0]) : void 0;
    }
    throw status != "error" ? getCompletion(...libraries) : GoogleMapsLoader.getError(libraries[0]);
  }
  const libs = [];
  for (let i = 0; i < l; i++) {
    const library = libraries[i];
    const lib = GoogleMapsLoader.get(library);
    if (!lib) {
      throw GoogleMapsLoader.getStatus(library) != "error" ? getCompletion(...libraries) : GoogleMapsLoader.getError(library);
    }
    libs.push(lib);
  }
  return libs;
};
var createUseLibrary_default = createUseLibrary;

export { createUseLibrary_default };
//# sourceMappingURL=chunk-F56M36Z4.js.map
//# sourceMappingURL=chunk-F56M36Z4.js.map