import { GoogleMapsLoader } from 'google-maps-js-api-loader';
import { useState, useEffect } from 'react';

// src/useGoogleMapsStatus/index.ts
var useGoogleMapsStatus = (library) => {
  const [status, setStatus] = useState(GoogleMapsLoader.getStatus(library));
  useEffect(() => {
    const currentStatus = GoogleMapsLoader.getStatus(library);
    if (currentStatus != status) {
      setStatus(currentStatus);
    }
    if (currentStatus != "loaded" && currentStatus != "error") {
      GoogleMapsLoader.getCompletion(library).finally(() => {
        setStatus(GoogleMapsLoader.getStatus(library));
      });
    }
  }, []);
  return status;
};
var useGoogleMapsStatus_default = useGoogleMapsStatus;

export { useGoogleMapsStatus_default };
//# sourceMappingURL=chunk-FN7OQ6OP.js.map
//# sourceMappingURL=chunk-FN7OQ6OP.js.map