'use strict';

var chunkQWMSBSOL_cjs = require('./chunk-QWMSBSOL.cjs');
var chunkLHLLIGUT_cjs = require('./chunk-LHLLIGUT.cjs');
var chunk2XKLZKVG_cjs = require('./chunk-2XKLZKVG.cjs');
var react = require('react');
var setRef = require('react-helpful-utils/setRef');
var googleMapsJsApiLoader = require('google-maps-js-api-loader');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var setRef__default = /*#__PURE__*/_interopDefault(setRef);

var isKeyOmitted = chunkQWMSBSOL_cjs.handleHas_default([
  "defaultOptions",
  "preventLoad"
]);
var handleComponent = (instancePath, connectedProps) => {
  const connectedEventsAndProps = chunkQWMSBSOL_cjs.getConnectedEventsAndProps_default(connectedProps);
  const [library, className] = instancePath;
  let isUnsafe = library != chunkLHLLIGUT_cjs.MAPS;
  let InstanceClass;
  return react.forwardRef((props, ref) => {
    if (isUnsafe) {
      const status = googleMapsJsApiLoader.GoogleMapsLoader.getStatus(library);
      if (status != "loaded") {
        throw (status != "error" ? props.preventLoad ? googleMapsJsApiLoader.GoogleMapsLoader.getCompletion : googleMapsJsApiLoader.GoogleMapsLoader.load : googleMapsJsApiLoader.GoogleMapsLoader.getError)(library);
      } else {
        isUnsafe = false;
      }
    }
    const map = react.useContext(chunk2XKLZKVG_cjs.MapContext_default);
    react.useLayoutEffect(() => {
      if (!InstanceClass) {
        InstanceClass = googleMapsJsApiLoader.GoogleMapsLoader.get(library)[className];
      }
      const instance = new InstanceClass({
        map,
        ...props.defaultOptions,
        ...props
      });
      setInstance(instance);
      setRef__default.default(ref, instance);
      return () => {
        instance.setMap(null);
        setRef__default.default(ref, null);
      };
    }, []);
    const setInstance = chunkQWMSBSOL_cjs.useHandlersAndProps_default(
      props,
      connectedEventsAndProps,
      isKeyOmitted
    );
    return null;
  });
};
var handleComponent_default = handleComponent;

exports.handleComponent_default = handleComponent_default;
//# sourceMappingURL=chunk-SPLLOINP.cjs.map
//# sourceMappingURL=chunk-SPLLOINP.cjs.map