'use strict';

var googleMapsJsApiLoader = require('google-maps-js-api-loader');
var react = require('react');

// src/useGoogleMapsStatus/index.ts
var useGoogleMapsStatus = (library) => {
  const [status, setStatus] = react.useState(googleMapsJsApiLoader.GoogleMapsLoader.getStatus(library));
  react.useEffect(() => {
    const currentStatus = googleMapsJsApiLoader.GoogleMapsLoader.getStatus(library);
    if (currentStatus != status) {
      setStatus(currentStatus);
    }
    if (currentStatus != "loaded" && currentStatus != "error") {
      googleMapsJsApiLoader.GoogleMapsLoader.getCompletion(library).finally(() => {
        setStatus(googleMapsJsApiLoader.GoogleMapsLoader.getStatus(library));
      });
    }
  }, []);
  return status;
};
var useGoogleMapsStatus_default = useGoogleMapsStatus;

exports.useGoogleMapsStatus_default = useGoogleMapsStatus_default;
//# sourceMappingURL=chunk-ZTZNHYFO.cjs.map
//# sourceMappingURL=chunk-ZTZNHYFO.cjs.map