/// <reference types="google.maps" />

type TypicalInstance = google.maps.MVCObject & {
    setOptions(options: any): void;
};
type OptionsOf<Instance extends TypicalInstance> = NonNullable<Parameters<Instance['setOptions']>[0]>;
type CommonProps<Instance extends TypicalInstance> = {
    defaultOptions: OptionsOf<Instance>;
};
type PreventLoadProps = {
    /**
     * if `true` loading of required lib will not be started by render of component
     */
    preventLoad?: boolean;
};

export type { CommonProps as C, PreventLoadProps as P };
