/// <reference types="google.maps" />

import * as google_maps_js_api_loader from 'google-maps-js-api-loader';

/**
 * Hook for awaiting loading of google.maps script or specific library/libraries
 * > Works only for [Suspense](https://react.dev/reference/react/Suspense) wrapped components
 */
declare const useGoogleMapsCompletion: {
    (): void;
    <L extends google_maps_js_api_loader.GoogleMapsLibrary>(library: L): google_maps_js_api_loader.GoogleMapsLibraries[L];
    <const A extends google_maps_js_api_loader.GoogleMapsLibrary[]>(...libraries: A): { [Index in keyof A]: google_maps_js_api_loader.GoogleMapsLibraries[A[Index]]; };
};

export { useGoogleMapsCompletion as default };
